#pragma once
#include <stdint.h>
#include <string>
#include "glm/glm.hpp"

namespace Deer {
    namespace EditorEngine {
        struct EntityStruct;
        extern EntityStruct activeEntity;

        // IN ANGEL SCRIPT IT LOOKS LIKE THIS
        //class Entity {
        //    int id;
        //    string name;
        //
        //    int childCount;
        //    bool isRoot;
        //
        //    Entity parent;
        //    Entiy getChild(int);
        //    Entity createChild(int);
        //
        //    void destroy();
        //    bool isDescendantOf
        //
        //    bool ==
        //}
        struct EntityStruct {
            EntityStruct(uint16_t entId = 0) : entityId(entId) { }
            uint16_t entityId;

            std::string getName();
            void setName(std::string&);
            
            int getId();
            bool exists();

            bool isRoot();
            void destroy();

            EntityStruct createChild(std::string&);

            void setParent(EntityStruct parent);
            EntityStruct getParent();

            bool isDescendantOf(EntityStruct parent);
            bool opEquals(const EntityStruct& other);

            //COMPONENTS
            EntityStruct getMeshComponent();
            bool hasMeshComponent();
            void removeMeshComponent();

            // This function can be adapted to get a specific transform since the data is the same
            EntityStruct getSelf();
        };

        struct EntityChildArrayStruct : EntityStruct{
            int getChildCount();
            EntityStruct getChild(int);
        };

        struct TransformComponentStruct : EntityStruct {
            glm::vec3 getPosition();
            glm::vec3 getScale();
            glm::vec3 getRotation();

            void setPosition(glm::vec3);
            void setScale(glm::vec3);
            void setRotation(glm::vec3);
        };

        struct MeshComponentStruct : EntityStruct {
            bool check_self();

            bool isActive();
            bool hasMesh();
            void clear();

            std::string getMesh();
            void setMesh(std::string&);
        };

        EntityStruct getRoot();
        void constructEntityStruct(int id, void* memory);
        void copyEntityStruct(int id, void* memory);

        void registerEntityStructs();
        void registerEntityFunctions();
    }
}